#!/usr/bin/env python3

import mr
import sys
from trees import Tree, Leaf, read_trees
from ucb import main

def rules(tree):
    """Yield the rules of a tree in left-corner form."""
    if tree.tag and type(tree) == Tree:
        children = tuple(b.tag for b in tree.branches)
        yield children[0], children[1:], tree.tag
        for b in tree.branches:
            for rule in rules(b):
                yield rule

@main
def run():
    for tree in read_trees(sys.stdin):
        for first, rest, tag in rules(tree):
            mr.emit(first, (rest, tag))
